package org.xbib.datastructures.multi;

import java.io.Serializable;

public class MultisetsImmutableEntry<E extends Object> extends MultisetsAbstractEntry<E>
        implements Serializable {
    private final E element;
    private final int count;

    MultisetsImmutableEntry(E element, int count) {
        this.element = element;
        this.count = count;
        if (count < 0) {
            throw new IllegalArgumentException("count");
        }
    }

    @Override
    public final E getElement() {
        return element;
    }

    @Override
    public final int getCount() {
        return count;
    }

    public MultisetsImmutableEntry<E> nextInBucket() {
        return null;
    }

    private static final long serialVersionUID = 0;
}
